/*
 *	dataanaly.cc
 */

/*	Copyright (C) 1999, 2000, 2001 Sebastian Biallas (sb@web-productions.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 *	this module was designed to regonize common data structures by
 *	analysing the way of accessing the data as well as analysing the
 *	data itself.
 */

#include <stdio.h>
#include <malloc.h>
#include "global.h"
#include "analy.h"
#include "dataanaly.h"

//#undef dprintf
//#define dprintf(msg...) printf(##msg)

/*
 *
 *	types to recognize:
 *		- bytes/words/dwords (by access)
 *		- strings (by examinating)
 *			- pascal
 *			- c
 *             - unicode
 *		- arrays (by access)
 *        - records (partially)
 */
void	dataanalyser::init(analyser *Analy)
{
	analy = Analy;
}

int 	dataanalyser::load(ht_stream_filter *f)
{
	return 0;
}

void	dataanalyser::done()
{
}

void	dataanalyser::access(ADDR Addr, OP op, int size)
{
}

void	dataanalyser::setaddrtype(ADDR Addr, taddrtypetype type, int subtype, int length)
{
	setaddrtype(analy->newaddr(Addr), type, subtype, length);
}

void	dataanalyser::setaddrtype(taddr *Addr, taddrtypetype type, int subtype, int length)
{
	dprintf("Addr %08lx set to %d (%d) length %d\n", Addr->addr, type, subtype, length);
	Addr->type.type = type;
	Addr->type.subtype = subtype;
	Addr->type.length = length;
}

void	dataanalyser::setcodeaddrtype(ADDR Addr, taddrcodesubtype subtype)
{
	setaddrtype(analy->newaddr(Addr), dtcode, subtype, 0);
}

void	dataanalyser::setcodeaddrtype(taddr *Addr, taddrcodesubtype subtype)
{
	setaddrtype(Addr, dtcode, subtype, 0);
}

void	dataanalyser::setintaddrtype(ADDR Addr, taddrintsubtype subtype, int length)
{
	setaddrtype(analy->newaddr(Addr), dtint, subtype, length);
}

void	dataanalyser::setintaddrtype(taddr *Addr, taddrintsubtype subtype, int length)
{
	setaddrtype(Addr, dtint, subtype, length);
}

void	dataanalyser::setfloataddrtype(ADDR Addr, taddrfloatsubtype subtype, int length)
{
	setaddrtype(analy->newaddr(Addr), dtfloat, subtype, length);
}

void	dataanalyser::setfloataddrtype(taddr *Addr, taddrfloatsubtype subtype, int length)
{
	setaddrtype(Addr, dtfloat, subtype, length);
}

void	dataanalyser::setarrayaddrtype(ADDR Addr, taddrarraysubtype subtype, int length)
{
	setaddrtype(analy->newaddr(Addr), dtarray, subtype, length);
}

void	dataanalyser::setarrayaddrtype(taddr *Addr, taddrarraysubtype subtype, int length)
{
	setaddrtype(Addr, dtarray, subtype, length);
}

void	dataanalyser::store(ht_stream_filter *f)
{
}

