/* 
 *	HT Editor
 *	htcfg.cc
 *
 *	Copyright (C) 1999, 2000, 2001 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htapp.h"
#include "htcfg.h"
#include "htctrl.h"
#include "htdebug.h"
#include "htstream.h"
#include "tools.h"

#include <stdlib.h>
#include <string.h>
#include <unistd.h>

char *config_file;

#define ht_config_magic MAGICD("HTCF")

/* current version */
#define ht_config_fileversion      ht_config_fileversion1
#define ht_config_header			ht_config_header1

/*** all config_headers ***/

/* VERSION 1 (for ht-0.3.993 and later) */
#define ht_config_fileversion1	1
struct ht_config_header1 {
	dword magic;
	dword fileversion;
};
/**/

int save_config()
{
	return 1;
	ht_file_stream *f=new ht_file_stream();
	f->init(config_file, SAM_WRITE | SAM_CREATE);
	if (f->get_error()) {
	    f->done();
	    delete f;
	    return 0;
	}		    
/* write config header */
	ht_config_header header;
	header.magic=ht_config_magic;
	header.fileversion=ht_config_fileversion;
	f->write(&header, sizeof header);
/* write config */
//	app->store(f);
	f->done();
	delete f;
	return 1;
}

int load_config()
{
	return 1;
	ht_file_stream *f=new ht_file_stream();
	f->init(config_file, SAM_READ);
	if (f->get_error()) {
	    f->done();
	    delete f;
	    return 0;
	}		    
/* read config header */
	ht_config_header header;
	f->read(&header, sizeof header);
	if (header.magic!=ht_config_magic) return 0;
	if (header.fileversion!=ht_config_fileversion) return 0;
/* read config */
//	((ht_app*)app)->load(f);
	   f->done();
	   delete f;
	return 1;
}

/*
 *   config objects
 */

#define MAX_CONFIG_OBJECTS 32

config_object cobj[MAX_CONFIG_OBJECTS];
int cobjs=0;

config_object *find_config_object(dword uid)
{
	for (int i=0; i<cobjs; i++) {
		if (cobj[i].uid==uid) {
			return &cobj[i];
		}
	}
	return 0;
}

void register_config_object(dword uid, object *(*loadconstructor)(ht_stream *s))
{
	if (!uid) HT_ERROR("registering with reserved id (0)");
	config_object *c=find_config_object(uid);
	if (!c) {
		cobj[cobjs].uid=uid;
		cobj[cobjs].loadconstructor=loadconstructor;
		cobjs++;
	} else {
		if (c->loadconstructor!=loadconstructor) HT_ERROR("registering different config_object with the same id");
	}
}

void unregister_config_object(dword uid)
{
	config_object *c=find_config_object(uid);
	if (c) {
		memmove(c, c+1, sizeof *c * (cobjs-(c-&cobj[0])-1));
		cobjs--;
	}
}

/*
 *	INIT
 */

int init_cfg()
{
#if defined(WIN32) || defined(__WIN32__)
	config_file=ht_strdup(".htconfig");
#elif defined(DJGPP)
	char *f="/ht.cfg";
	char *d=dirname(this_app);
	config_file=(char*)malloc(strlen(d)+strlen(f)+1);
	strcpy(config_file, d);
	strcat(config_file, f);
#else
	config_file=ht_strdup("~/.htconfig");
#endif
	return 1;
}

/*
 *	DONE
 */

void done_cfg()
{
	delete config_file;
}

