/* 
 *	HT Editor
 *	hthist.h
 *
 *	Copyright (C) 1999, 2000, 2001 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef HTHIST_H
#define HTHIST_H

class vs_stack;

#include "htobj.h"

/*
 *	histories
 */

#define HISTATOM_GOTO		0x00004f47
#define HISTATOM_FILE		0x00004f48
#define HISTATOM_SEARCH_BIN	0x00004f49
#define HISTATOM_SEARCH_CASM	0x00004f4a
#define HISTATOM_SEARCH_TEXT	0x00004f4b
#define HISTATOM_ASSEMBLER	0x00004f4c

/*
 *	CLASS ht_history_entry
 */

class ht_history_entry: public ht_data {
public:
	ht_data_string *desc;
	void *data;

	ht_history_entry(char *str, void *_data);
	~ht_history_entry();
};

bool insert_history_entry(char *name, void *data, ht_list *history);

/*
 *	INIT
 */

void init_hist();

/*
 *	DONE
 */

void done_hist();

#endif /* HTHIST_H */
