/* 
 *	HT Editor
 *	htle.cc
 *
 *	Copyright (C) 1999, 2000, 2001 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htapp.h"
#include "htle.h"
#include "htlehead.h"
#include "htleimg.h"
#include "htleobj.h"
#include "htleent.h"
#include "htlepage.h"
#include "htnewexe.h"
#include "lestruct.h"

format_view_if *htle_ifs[] = {
	&htleheader_if,
	&htlepagemaps_if,
	&htleobjects_if,
	&htleentrypoints_if,
	&htleimage_if,
	0
};

ht_view *htle_init(bounds *b, ht_stream *file, ht_format_group *format_group)
{
	dword lemagic=0;
	STREAMOFS h=get_newexe_header_ofs(file);
	file->seek(h);
	file->read(&lemagic, 2);
	if (lemagic!=LE_MAGIC) return 0;

	ht_le *g=new ht_le();
	g->init(b, file, htle_ifs, format_group, h);
	return g;
}

format_view_if htle_if = {
	htle_init,
	0
};

void ht_le::init(bounds *b, ht_stream *file, format_view_if **ifs, ht_format_group *format_group, STREAMOFS h)
{
	ht_format_group::init(b, VO_BROWSABLE | VO_SELECTABLE | VO_RESIZE, DESC_LE, file, 0, 0, format_group);
	VIEW_DEBUG_NAME("ht_le");

	LOG("%s: LE: found header at %08x", file->get_name(), h);
	ht_le_shared_data *le_shared=new ht_le_shared_data;
	shared_data=le_shared;
	le_shared->v_header=0;
	le_shared->v_objects=0;
	le_shared->v_pagemaps=0;
	le_shared->v_image=0;
	le_shared->hdr_ofs=h;
	file->seek(h);
	file->read(&le_shared->hdr, sizeof le_shared->hdr);

	shared_data=le_shared;

	ht_format_group::init_ifs(ifs);
}

void ht_le::done()
{
	ht_format_group::done();
}

