/*
 *   htkeyb.cc - LINUX implementation
 */

#include "config.h"
#include CURSES_HDR

#include "htkeyb.h"

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
			
int htkey2alt(int key)
{
    return HT_META_KEY(key);
}

int htalt2key(int key)
{
    if (HT_IS_META_KEY(key)) return HT_UNMETA_KEY(key);
    return 0;
}

int htkeypressed()
{
	int i=getch();
	if (i!=-1) ungetch(i);
	return (i!=-1);
}

int htgetkey()
{
	int c=getch();
	if (c=='\e') {
		c=getch();
		   if ((c==-1) || (c=='\e')) c='\e'; else c=HT_META_KEY(c);
	}
	return c;
}

void ht_sleep(int sec, int usec)
{
	timeval tm;
	fd_set zerofds;
	FD_ZERO(&zerofds);
	
	tm.tv_sec=sec;
	tm.tv_usec=usec;
	select(0, &zerofds, &zerofds, &zerofds, &tm);
}

int init_keyb()
{
    return 1;
}

int done_keyb()
{
    return 1;
}

