/*
 *	HT Editor
 *	htkeyb.h (WIN32 implementation)
 *
 *	Copyright (C) 1999, 2000, 2001 Sebastian Biallas (sb@web-productions.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTKEYB_H__
#define __HTKEYB_H__

int htkey2alt(int key);
int htalt2key(int key);

int htkeypressed();
int htgetkey();

void init_keyb();
void done_keyb();

#define HT_VK                  0x0300
#define HT_VK_ALT              0x1000
#define HT_VK_SHIFT            0x2000
#define HT_VK_CTRL             0x3000

#define K_Control_A            (0x001+HT_VK_CTRL)
#define K_Control_B            (0x002+HT_VK_CTRL)
#define K_Control_C            (0x003+HT_VK_CTRL)
#define K_Control_D            (0x004+HT_VK_CTRL)
#define K_Control_E            (0x005+HT_VK_CTRL)
#define K_Control_F            (0x006+HT_VK_CTRL)
#define K_Control_G            (0x007+HT_VK_CTRL)
#define K_BackSpace            0x008
#define K_Control_H            (0x008+HT_VK_CTRL)
#define K_Tab                  0x009
#define K_Control_I            (0x009+HT_VK_CTRL)
#define K_LineFeed             0x00a
#define K_Control_J            (0x00a+HT_VK_CTRL)
#define K_Control_K            (0x00b+HT_VK_CTRL)
#define K_Control_L            (0x00c+HT_VK_CTRL)
#define K_Return               0x00d
#define K_Control_M            (0x00d+HT_VK_CTRL)
#define K_Control_N            (0x00e+HT_VK_CTRL)
#define K_Control_O            (0x00f+HT_VK_CTRL)
#define K_Control_P            (0x010+HT_VK_CTRL)
#define K_Control_Q            (0x011+HT_VK_CTRL)
#define K_Control_R            (0x012+HT_VK_CTRL)
#define K_Control_S            (0x013+HT_VK_CTRL)
#define K_Control_T            (0x014+HT_VK_CTRL)
#define K_Control_U            (0x015+HT_VK_CTRL)
#define K_Control_V            (0x016+HT_VK_CTRL)
#define K_Control_W            (0x017+HT_VK_CTRL)
#define K_Control_X            (0x018+HT_VK_CTRL)
#define K_Control_Y            (0x019+HT_VK_CTRL)
#define K_Control_Z            (0x01a+HT_VK_CTRL)
#define K_Control_LBracket     0x01b
#define K_Escape               0x01b
#define K_Control_BackSlash    0x01c
#define K_Control_RBracket     0x01d
#define K_Control_Caret        0x01e
#define K_Control_Underscore   0x01f
#define K_Space                0x020
#define K_ExclamationPoint     0x021
#define K_DoubleQuote          0x022
#define K_Hash                 0x023
#define K_Dollar               0x024
#define K_Percent              0x025
#define K_Ampersand            0x026
#define K_Quote                0x027
#define K_LParen               0x028
#define K_RParen               0x029
#define K_Star                 0x02a
#define K_Plus                 0x02b
#define K_Comma                0x02c
#define K_Dash                 0x02d
#define K_Period               0x02e
#define K_Slash                0x02f
#define K_Colon                0x03a
#define K_SemiColon            0x03b
#define K_LAngle               0x03c
#define K_Equals               0x03d
#define K_RAngle               0x03e
#define K_QuestionMark         0x03f
#define K_At                   0x040
#define K_LBracket             0x05b
#define K_BackSlash            0x05c
#define K_RBracket             0x05d
#define K_Caret                0x05e
#define K_UnderScore           0x05f
#define K_BackQuote            0x060
#define K_LBrace               0x07b
#define K_Pipe                 0x07c
#define K_RBrace               0x07d
#define K_Tilde                0x07e
#define K_Control_Backspace    (K_BackSpace+HT_VK_CTRL)

#define K_Alt_Escape           (K_Escape+HT_VK_ALT)
#define K_Control_At           0x103
#define K_Alt_Backspace        (K_BackSpace+HT_VK_ALT)
#define K_BackTab              0x10f
#define K_Alt_Q                ('q'+HT_VK_ALT)
#define K_Alt_W                ('w'+HT_VK_ALT)
#define K_Alt_E                ('e'+HT_VK_ALT)
#define K_Alt_R                ('r'+HT_VK_ALT)
#define K_Alt_T                ('t'+HT_VK_ALT)
#define K_Alt_Y                ('y'+HT_VK_ALT)
#define K_Alt_U                ('u'+HT_VK_ALT)
#define K_Alt_I                ('i'+HT_VK_ALT)
#define K_Alt_O                ('o'+HT_VK_ALT)
#define K_Alt_P                ('p'+HT_VK_ALT)
#define K_Alt_LBracket         0x11a
#define K_Alt_RBracket         0x11b
#define K_Alt_Return           0x11c
#define K_Alt_A                ('a'+HT_VK_ALT)
#define K_Alt_S                ('s'+HT_VK_ALT)
#define K_Alt_D                ('d'+HT_VK_ALT)
#define K_Alt_F                ('f'+HT_VK_ALT)
#define K_Alt_G                ('g'+HT_VK_ALT)
#define K_Alt_H                ('h'+HT_VK_ALT)
#define K_Alt_J                ('j'+HT_VK_ALT)
#define K_Alt_K                ('k'+HT_VK_ALT)
#define K_Alt_L                ('l'+HT_VK_ALT)
#define K_Alt_Semicolon        0x127
#define K_Alt_Quote            0x128
#define K_Alt_Backquote        0x129
#define K_Alt_Backslash        0x12b
#define K_Alt_Z                ('z'+HT_VK_ALT)
#define K_Alt_X                ('x'+HT_VK_ALT)
#define K_Alt_C                ('c'+HT_VK_ALT)
#define K_Alt_V                ('v'+HT_VK_ALT)
#define K_Alt_B                ('b'+HT_VK_ALT)
#define K_Alt_N                ('n'+HT_VK_ALT)
#define K_Alt_M                ('m'+HT_VK_ALT)
#define K_Alt_Comma            0x133
#define K_Alt_Period           0x134
#define K_Alt_Slash            0x135
#define K_Alt_KPStar           0x137
#define K_F1                   (VK_F1+HT_VK)
#define K_F2                   (VK_F2+HT_VK)
#define K_F3                   (VK_F3+HT_VK)
#define K_F4                   (VK_F4+HT_VK)
#define K_F5                   (VK_F5+HT_VK)
#define K_F6                   (VK_F6+HT_VK)
#define K_F7                   (VK_F7+HT_VK)
#define K_F8                   (VK_F8+HT_VK)
#define K_F9                   (VK_F9+HT_VK)
#define K_F10                  (VK_F10+HT_VK)
#define K_Home                 (VK_HOME+HT_VK)
#define K_Up                   (VK_UP+HT_VK)
#define K_PageUp               (VK_PRIOR+HT_VK)
#define K_Alt_KPMinus          0x14a
#define K_Left                 (VK_LEFT+HT_VK)
#define K_Center               0x14c
#define K_Right                (VK_RIGHT+HT_VK)
#define K_Alt_KPPlus           0x14e
#define K_End                  (VK_END+HT_VK)
#define K_Down                 (VK_DOWN+HT_VK)
#define K_PageDown             (VK_NEXT+HT_VK)
#define K_Insert               (VK_INSERT+HT_VK)
#define K_Delete               (VK_DELETE+HT_VK)
#define K_Shift_F1             (K_F1+HT_VK_SHIFT)
#define K_Shift_F2             (K_F2+HT_VK_SHIFT)
#define K_Shift_F3             (K_F3+HT_VK_SHIFT)
#define K_Shift_F4             (K_F4+HT_VK_SHIFT)
#define K_Shift_F5             (K_F5+HT_VK_SHIFT)
#define K_Shift_F6             (K_F6+HT_VK_SHIFT)
#define K_Shift_F7             (K_F7+HT_VK_SHIFT)
#define K_Shift_F8             (K_F8+HT_VK_SHIFT)
#define K_Shift_F9             (K_F9+HT_VK_SHIFT)
#define K_Shift_F10            (K_F10+HT_VK_SHIFT)
#define K_Control_F1           (K_F1+HT_VK_CTRL)
#define K_Control_F2           (K_F2+HT_VK_CTRL)
#define K_Control_F3           (K_F3+HT_VK_CTRL)
#define K_Control_F4           (K_F4+HT_VK_CTRL)
#define K_Control_F5           (K_F5+HT_VK_CTRL)
#define K_Control_F6           (K_F6+HT_VK_CTRL)
#define K_Control_F7           (K_F7+HT_VK_CTRL)
#define K_Control_F8           (K_F8+HT_VK_CTRL)
#define K_Control_F9           (K_F9+HT_VK_CTRL)
#define K_Control_F10          (K_F10+HT_VK_CTRL)
#define K_Alt_F1               (K_F1+HT_VK_ALT)
#define K_Alt_F2               (K_F2+HT_VK_ALT)
#define K_Alt_F3               (K_F3+HT_VK_ALT)
#define K_Alt_F4               (K_F4+HT_VK_ALT)
#define K_Alt_F5               (K_F5+HT_VK_ALT)
#define K_Alt_F6               (K_F6+HT_VK_ALT)
#define K_Alt_F7               (K_F7+HT_VK_ALT)
#define K_Alt_F8               (K_F8+HT_VK_ALT)
#define K_Alt_F9               (K_F9+HT_VK_ALT)
#define K_Alt_F10              (K_F10+HT_VK_ALT)
#define K_Control_Print	       0x172
#define K_Control_Left         (K_Left+HT_VK_CTRL)
#define K_Control_Right        (K_Right+HT_VK_CTRL)
#define K_Control_End          (K_End+HT_VK_CTRL)
#define K_Control_PageDown     (K_PageDown+HT_VK_CTRL)
#define K_Control_Home         (K_Home+HT_VK_CTRL)
#define K_Alt_1                ('1'+HT_VK_ALT)
#define K_Alt_2                ('2'+HT_VK_ALT)
#define K_Alt_3                ('3'+HT_VK_ALT)
#define K_Alt_4                ('4'+HT_VK_ALT)
#define K_Alt_5                ('5'+HT_VK_ALT)
#define K_Alt_6                ('6'+HT_VK_ALT)
#define K_Alt_7                ('7'+HT_VK_ALT)
#define K_Alt_8                ('8'+HT_VK_ALT)
#define K_Alt_9                ('9'+HT_VK_ALT)
#define K_Alt_0                ('0'+HT_VK_ALT)
#define K_Alt_Dash             0x182
#define K_Alt_Equals           0x183
#define K_Control_PageUp       (K_PageUp+HT_VK_CTRL)
#define K_F11                  (VK_F11+HT_VK)
#define K_F12                  (VK_F12+HT_VK)
#define K_Shift_F11            (K_F11+HT_VK_SHIFT)
#define K_Shift_F12            (K_F12+HT_VK_SHIFT)
#define K_Control_F11          (K_F11+HT_VK_CTRL)
#define K_Control_F12          (K_F12+HT_VK_CTRL)
#define K_Alt_F11              (K_F11+HT_VK_ALT)
#define K_Alt_F12              (K_F12+HT_VK_ALT)
#define K_Control_Up           (K_Up+HT_VK_CTRL)
#define K_Control_KPDash       0x18e
#define K_Control_Center       0x18f
#define K_Control_KPPlus       0x190
#define K_Control_Down         (K_Down+HT_VK_CTRL)
#define K_Control_Insert       0x192
#define K_Control_Delete       0x193
#define K_Control_KPSlash      0x195
#define K_Control_KPStar       0x196
#define K_Alt_EHome            0x197
#define K_Alt_EUp              0x198
#define K_Alt_EPageUp          0x199
#define K_Alt_ELeft            0x19b
#define K_Alt_ERight           0x19d
#define K_Alt_EEnd             0x19f
#define K_Alt_EDown            0x1a0
#define K_Alt_EPageDown        0x1a1
#define K_Alt_EInsert          0x1a2
#define K_Alt_EDelete          0x1a3
#define K_Alt_KPSlash          0x1a4
#define K_Alt_Tab              0x1a5
#define K_Alt_Enter            0x1a6

#define K_EHome                0x247
#define K_EUp                  0x248
#define K_EPageUp              0x249
#define K_ELeft                0x24b
#define K_ERight               0x24d
#define K_EEnd                 0x24f
#define K_EDown                0x250
#define K_EPageDown            0x251
#define K_EInsert              0x252
#define K_EDelete              0x253
#define K_Control_ELeft        0x273
#define K_Control_ERight       0x274
#define K_Control_EEnd         0x275
#define K_Control_EPageDown    0x276
#define K_Control_EHome        0x277
#define K_Control_EPageUp      0x284
#define K_Control_EUp          0x28d
#define K_Control_EDown        0x291
#define K_Control_EInsert      0x292
#define K_Control_EDelete      0x293

#define K_Shift_Up             (HT_VK_SHIFT+K_Up)
#define K_Shift_Down           (HT_VK_SHIFT+K_Down)
#define K_Shift_Left           (HT_VK_SHIFT+K_Left)
#define K_Shift_Right          (HT_VK_SHIFT+K_Right)
#define K_Shift_PageUp         (HT_VK_SHIFT+K_PageUp)
#define K_Shift_PageDown       (HT_VK_SHIFT+K_PageDown)

#define K_Shift_Home           (HT_VK_SHIFT+K_Home)
#define K_Shift_End            (HT_VK_SHIFT+K_End)
#define K_Shift_Delete         (HT_VK_SHIFT+K_Delete)
#define K_Shift_Insert         (HT_VK_SHIFT+K_Insert)

#endif /* !__HTKEYB_H__ */
