/* 
 *	HT Editor
 *	main.cc
 *
 *	Copyright (C) 1999, 2000, 2001 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>

#include "htapp.h"
#include "htatom.h"
#include "htcfg.h"
#include "htclipboard.h"
#include "htcurses.h"
#include "hthelp.h"
#include "hthist.h"
#include "htkeyb.h"
#include "htidle.h"
#include "htmenu.h"
#include "htpal.h"
#include "htinfo.h"
#include "htreg.h"

char *htcopyrights[]=
{
	ht_loadtitle,
	htanalyser_loadtitle,
	0
};

void copyright()
{
	char **copyrights=htcopyrights;
	while (*copyrights) {
		printf(*copyrights);
		printf("\n");
		copyrights++;
	}
	printf(htlicenseinfo);
}

void init()
{
	init_atom();
	init_registry();
	init_pal();
	init_keyb();
	init_idle();
	init_menu();
	init_app();
	init_help();
	init_hist();
	init_clipboard();
	init_cfg();
/* test: */
/*	htfile *f=new htrawfile("inf/infview.ger", "rb");*/
/*	ht_file_stream *f=new ht_file_stream();
	f->init("info/autoconf.info", SAM_READ);
	if (f->get_error()) {
		printf("helpfile not found !\n");
		exit(1);
	}
	read_info_file(f);
	f->done();
	delete f;*/
}

void done()
{
	done_cfg();
	done_clipboard();
	done_hist();
	done_help();
	done_app();
	done_menu();
	done_idle();
	done_keyb();
	done_pal();
	done_registry();
	done_atom();
}

int main(int argc, char *argv[])
{
	this_app=argv[0];

	init();

	load_config();
	((ht_app*)app)->sendmsg(msg_draw);

	char **copyrights=htcopyrights;
	while (*copyrights) {
		LOG(*copyrights);
		copyrights++;
	}

	int filecount=0;
	for (int i=1; i<argc; i++) {
		if (((ht_app*)app)->create_file_window(argv[i])) {
			filecount++;
		}
	}

	((ht_app*)app)->run(0);
	
	save_config();
	done();
}

