/*
 *      HT Editor
 *      store.h
 *
 *      Copyright (C) 1999, 2000, 2001 Sebastian Biallas (sb@web-productions.de)
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License version 2 as
 *      published by the Free Software Foundation.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef STORE_H
#define STORE_H

#include "global.h"
#include "common.h"

class ht_stream;

class ht_stream_filter: public object {
public:
	ht_stream *stream;
			void init(ht_stream *s);
			void done();
	virtual void *get_binary(int size, char *desc);
	virtual bool    get_bool(char *desc);
	virtual int  get_int_dec(int size, char *desc);
	virtual int  get_int_hex(int size, char *desc);
	virtual object *get_object(char *name);
	virtual void get_seperator();
	virtual char *get_string(char *desc);
	virtual void put_binary(void *mem, int size, char *desc);
	virtual void    put_bool(bool b, char *desc);
	virtual void put_info(char *info);
	virtual void put_int_dec(int a, int size, char *desc);
	virtual void put_int_hex(int a, int size, char *desc);
	virtual void put_object(object *obj, char *name);
	virtual void put_seperator();
	virtual void put_string(char *string, char *desc);
};

#include "htstream.h"

class bin_filter: public ht_stream_filter {
public:
	virtual void *get_binary(int size, char *desc);
	virtual bool    get_bool(char *desc);
	virtual int  get_int_dec(int size, char *desc);
	virtual int  get_int_hex(int size, char *desc);
	virtual object *get_object(char *name);
	virtual void get_seperator();
	virtual char *get_string(char *desc);
	virtual void put_binary(void *mem, int size, char *desc);
	virtual void    put_bool(bool b, char *desc);
	virtual void put_info(char *info);
	virtual void put_int_dec(int a, int size, char *desc);
	virtual void put_int_hex(int a, int size, char *desc);
	virtual void put_object(object *obj, char *name);
	virtual void put_seperator();
	virtual void put_string(char *string, char *desc);
};

class txt_filter: public ht_stream_filter {
public:
	int     indent;
			void init(ht_stream *s);
			void done();
	virtual void *get_binary(int size, char *desc);
	virtual bool    get_bool(char *desc);
	virtual int  get_int_dec(int size, char *desc);
	virtual int  get_int_hex(int size, char *desc);
	virtual object *get_object(char *name);
	virtual void get_seperator();
	virtual char *get_string(char *desc);
	virtual void put_binary(void *mem, int size, char *desc);
	virtual void    put_bool(bool b, char *desc);
	virtual void put_info(char *info);
	virtual void put_int_dec(int a, int size, char *desc);
	virtual void put_int_hex(int a, int size, char *desc);
	virtual void put_object(object *obj, char *name);
	virtual void put_seperator();
	virtual void put_string(char *string, char *desc);

			void put_s(char *s);
			void put_char(char c);
};

#endif
